// --------------------- interface functions ---------------------
// checksum = 10106


//needs the shared library libbossa.so obtains by : gcc -shared .../bossa/load.c -o /usr/lib/libbossa.so

using System;
using System.Runtime.InteropServices;
using System.Threading;

public class user_Fixed_priority6
{


	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int bossa_attach_info(int parent);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int bossa_connect(int parent, int child, int argc, int *argv);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int bossa_connect_root(int new_root, int argc, int *argv);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int bossa_disconnect(int tgt);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int bossa_print(string s, int sz);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int scheduler_names(string s, int sz);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe void load_module(string s);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int find_scheduler(string b, string s);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe void mount(string parent_name, string child_name,
			int child_property_count,
			int *child_properties);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe void mount_root(string new_root_name,
			int child_property_count,
			int *child_properties);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe void unmount(string tgt_name);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int open(
		string filename,
		uint flags);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int ioctl(int d,
		uint requete,
		void* lpInBuffer);
		//int lpCompletionRoutine);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe void close(int hFile);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int system(string command);

public static unsafe int install_module(string path) {
	return system("cil2module " + path);
}

	const uint GENERIC_READ  = 0x80000000;
	const uint GENERIC_WRITE = 0x40000000;
	const uint OPEN_EXISTING = 3;
	const uint FILE_FLAG_NO_BUFFERING = 0x20000000;
	//const  int SIZE_INT = System.Runtime.InteropServices.Marshal.SizeOf(0);
	const  int SIZE_INT = 4;
	const uint IOCTL_BASE = (1U << 30) | (BOSSA_ID_NUM << 8) | (SIZE_INT << 16);


	const uint BOSSA_ID_NUM = 0xCE;
	const uint IOCTL_SETIMPORTANCE      = IOCTL_BASE | (0 << 0);
	private const string _BOSSA_DEVICE_NAME = "bossa_Fixed_priority6";




struct dev_Fixed_priority6_attach_struct {
  int _checksum;
  public int s_11;
  public int importance_12;
};

struct dev_Fixed_priority6_setImportance_struct {
  public int s;
  public int priority;
};

public static unsafe int Fixed_priority6_setImportance(int s, int priority) {
  dev_Fixed_priority6_setImportance_struct _data;
  _data.s = s;
  _data.priority = priority;
  {
    int fd, res;
    fd = open("/dev/bossa/" + _BOSSA_DEVICE_NAME, GENERIC_READ | GENERIC_WRITE);
    res = ioctl(fd,IOCTL_SETIMPORTANCE,&_data);
    if (res!=0) Console.Error.WriteLine("setImportance");
    close(fd);
    return res;
  }
}
}

